package se.jernlas.swing.gem;

import se.jernlas.swing.gem.types.TextType;

/**
 * Analyzes an AnalyzableText in order to identify matching TextTypes.
 * 
 * @author jernlas
 */
public interface TextAnalyzer {

   /**
    * Adds a TextType to the list of TextTypes to identify.
    * @param type The TextType to add
    */
   public void addTextType(TextType type);
   
   /**
    * Perform the actual analysis.
    * @param text The AnalyzableText to analyze
    */
   public void analyzeText(AnalyzableText text);
   
   /**
    * Removes a TextType from the list of identifiable types.
    * @param type The TextType to remove. 
    */
   public void removeTextType(TextType type);
   
}
