package se.jernlas.swing.gem.types;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.regex.Pattern;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JOptionPane;

/**
 * An informal letter TextType. Singleton. Not intended for direct use, accessed
 * as a static field in TextType.
 * 
 * @author jernlas
 */
class InformalLetterType extends TextType {

   /**
    * The singleton instance
    */
   private final static InformalLetterType instance = new InformalLetterType();

   /**
    * Prevent others from instantiating.
    */
   private InformalLetterType() {
   }

   @Override
   public JComponent getTip() {
      final JButton b = new JButton(
            "Det verkar som att du vill skriva ett informellt brev...");
      b.addActionListener(new ActionListener() {

         @Override
         public void actionPerformed(ActionEvent e) {
            JOptionPane.showMessageDialog(b,
                  "This is only an example application...");
         }

      });
      return b;

   }

   @Override
   public boolean isThisType(String text) {
      return Pattern.matches("^Hejsan.*", text);
   }

   /**
    * Gets the singleton instance.
    * 
    * @return the instance.
    */
   public static InformalLetterType getInstance() {
      return instance;
   }

}
